_=[[ variableCapacity
--------------------------------------------------------------------------------------------------------------------
Author: Sven777b (ICQ#95176001)

Version 1.0 - 03.05.2012 

frei verwendbar - keine erlaubnis ntig  |  free for use - no permission needed.
Modifikationen erst nach Rcksprache!    |  modifications only with my permission.

Hinweis: das Kopieren von Sourcecode ist strafbar nach UrhG 2.1
--------------------------------------------------------------------------------------------------------------------
Moddesc: <specialization name="variableCapacity" className="variableCapacity" filename="variableCapacity.lua"/>
Fahrzeug XML:
- die Kapazitt in den jeweiligen FillPlanes ergnzen zB:
<fillPlane type="wheat" capacity="20000">

]]

variableCapacity = {};

function variableCapacity.prerequisitesPresent(specializations)
    return SpecializationUtil.hasSpecialization(Fillable, specializations);
end;

function variableCapacity:load(xmlFile)
	self.capacities = {};
	local i = 0;
	while true do
		local key = string.format("vehicle.fillPlanes.fillPlane(%d)", i);
		if not hasXMLProperty(xmlFile, key) then break; end;
		local fillType = getXMLString(xmlFile, key.."#type");
		if fillType ~= nil then
			local cap = getXMLFloat(xmlFile,key.."#capacity");
			if cap == nil then
				cap = self.capacity;
			end;
			self.capacities[fillType] = cap;
		end;
		i=i+1;
	end;
	self.defaultCapacity = self.capacity;
	self.currentCapacityType = Fillable.FILLTYPE_UNKNOWN;
end;

function variableCapacity:delete()
end;

function variableCapacity:mouseEvent(posX, posY, isDown, isUp, button)
end;

function variableCapacity:keyEvent(unicode, sym, modifier, isDown)
end;

function variableCapacity:update(dt)
end;

function variableCapacity:updateTick(dt)
	if self.currentFillType ~= self.currentCapacityType then
		self.currentCapacityType = self.currentFillType;
		if self.currentFillType == Fillable.FILLTYPE_UNKNOWN then
			self.capacity = self.defaultCapacity;
		else
			local ftn = Fillable.fillTypeIntToName[self.currentFillType];
			self.capacity = Utils.getNoNil(self.capacities[ftn],self.defaultCapacity);
		end;
	end;
end;

function variableCapacity:draw()
end;

function variableCapacity:loadFromAttributesAndNodes(xmlFile, key, resetVehicles)
    local fillLevel = getXMLFloat(xmlFile, key.."#fillLevel");
    local fillType = getXMLString(xmlFile, key.."#fillType");
    if fillLevel ~= nil and fillType ~= nil then
        local fillTypeInt = Fillable.fillTypeNameToInt[fillType];
        if fillTypeInt ~= nil then
            self.capacity = Utils.getNoNil(self.capacities[fillType],self.defaultCapacity);
            self:setFillLevel(fillLevel, fillTypeInt);
            print("Filltype : "..fillType.." Cap: "..self.capacity);
        end;
    end;
    return BaseMission.VEHICLE_LOAD_OK;
end;

function variableCapacity:readStream(streamId, connection)
    if connection:getIsServer() then
        local fillLevel = streamReadFloat32(streamId);
        local fillType = streamReadUIntN(streamId, Fillable.sendNumBits);
        self.capacity = Utils.getNoNil(self.capacities[Fillable.fillTypeIntToName[fillType]],self.defaultCapacity);
        self:setFillLevel(fillLevel, fillType);
    end;
end;

function variableCapacity:writeStream(streamId, connection)
    if not connection:getIsServer() then
        streamWriteFloat32(streamId, self.fillLevel);
        streamWriteUIntN(streamId, self.currentFillType, Fillable.sendNumBits);
    end;
end;
